Std Pieza

From FreeCAD Documentation
This page is a translated version of the page Std Part and the translation is 14% complete.
Outdated translations are marked like this.

Std Pieza

Ubicación en el Menú
Ninguna
Entornos de trabajo
Todos
Atajo de teclado por defecto
Ninguno
Introducido en versión
0.17
Ver también
Std Grupo, Cuerpo PartDesign

Descripción

Std Part (internamente llamado App Part) es un contenedor de propósito general que mantiene juntos un grupo de objetos para que puedan moverse juntos como una unidad en la vista 3D.

El elemento Std Part se desarrolló para ser el bloque de construcción básico para crear [[[assembly|ensambles]] mecánicos. En particular, está destinado a organizar objetos que tengan un Part TopoShape, como Part Primitives, PartDesign Bodies y otras Part Features . El Std Part proporciona un Origen de objeto con ejes locales X, Y y Z, y planos estándar, que pueden ser usados como referencia a la posición de los objetos contenidos. Además, Std Parts pueden anidarse dentro de otras partes de Std Parts para crear ensambles grandes a partir de sub-ensambles más pequeños.

Although it is primarily intended for solid bodies, the Std Part can be used to manage any object that has a Placement property, so it can also contain Mesh Features, sketches, and other objects derived from the App GeoFeature class.

Part se encuentra en la barra de herramientas Estructura que se muestra en todos los ambientes de trabajo.

The Std Part tool is not defined by a particular workbench, but by the base system, thus it is found in the structure toolbar that is available in all workbenches. To group objects arbitrarily without considering their position, use Std Group; this object does not affect the placements of the elements that it contains, it is essentially just a folder that is used to keep the Tree view organized.

Left: elements inside a Std Part in the Tree view. Right: objects positioned in space, referred to the Origin of the Std Part.

Como utilizar

  • Presione el botón Create part en la barra de herramientas. La Part se activa automáticamente.
  • Haga doble clic en la Part en el árbol del Modelo para activarlo o desactivarlo.
  • Para agregar objetos a una Part, arrástrelos y suéltelos sobre la Part en el árbol del Modelo.
  • Para eliminar objetos de una Part, arrástrelos y suéltelos de la Part y en la etiqueta del documento en la parte superior del árbol del modelo.

Notes

  • An object can only belong to a single Part.
  • 3D operations like Part Boolean cannot be applied to Parts. For example, you cannot select two Parts, and perform a Part Fuse or Part Cut.

Propiedades

The Std Part, internally called App Part (App::Part class), is derived from the App GeoFeature (App::GeoFeature class) and inherits all its properties. It also has several additional properties. Notably properties that help it manage information in the context of an assembly, for example, DatosType, DatosId, DatosLicense, DatosLicenseURL and DatosGroup.

These are the properties available in the property editor. Hidden properties can be shown by using the Show all command in the context menu of the property editor.

Data

Base

  • Datos Id: ID (Número de pieza) del artículo. Este campo es opcional.
  • Datos License: la licencia bajo la cual se lanza la Part.
  • Datos License URL: la dirección web donde se pueden encontrar los términos de licencia.
  • Datos Placement: especifica la orientación y la posición de la Part en el espacio 3D. Ver Placement.
  • Datos Label: la label/etiqueta es el nombre dado a la operación. Este nombre se puede cambiar a su conveniencia.
  • Datos Group: enumera los objetos a los que se hace referencia.

View

Display Options

  • VistaDisplay Mode (Enumeration): Group.
  • VistaShow In Tree (Bool): if it is true, the object appears in the Tree view. Otherwise, it is set as invisible.
  • VistaVisibility (Bool): if it is true, the object appears in the 3D view; otherwise it is invisible. By default this property can be toggled on and off by pressing the Space bar in the keyboard.

Selection

  • VistaOn Top When Selected (Enumeration): Disabled (default), Enabled, Object, Element.
  • VistaSelection Style (Enumeration): Shape (default), BoundBox. If the option is Shape, the entire shape (vertices, edges, and faces) will be highlighted in the 3D view; if it is BoundBox only the bounding box will be highlighted.

Detailed explanation

Estado activo

Un documento de FreeCAD puede contener varias Part. Solo una Part puede estar activa a la vez. Una Part activa se mostrará en el árbol con un color de fondo azul claro.

An open document can contain multiple Parts. But only one Part can be active. The active Part is displayed in the tree view with the background color specified by the Active container value in the preferences editor (by default, light blue). It will also be shown with bold text.

To activate or de-activate a Part:

  • Double click on it on the Tree view, or
  • Open the context menu (right click) and select Toggle active part.

Document with two Std Parts, of which the second one is active.

Origen

The Origin consta de los tres ejes estándar (X, Y, Z) y tres planos estándar (XY, XZ y YZ). Sketches se pueden unir a estos planos. Todos los elementos dentro de la Part están referenciados al Origen de la Part; lo que significa que la Part se puede mover y rotar en referencia al sistema de coordenadas global sin afectar la ubicación de los elementos en su interior.

The Origin consists of the three standard axes (X, Y, Z) and three standard planes (XY, XZ and YZ). Sketches and other objects can be attached to these elements when creating them.

Left: Part Origin in the Tree view. Right: representation of the Origin elements in the 3D view.

Note: the Origin is an App Origin object (App::Origin class), while the axes and planes are objects of type App::Line and App::Plane respectively. Each of these elements can be hidden and unhidden individually with the Space bar; this is useful to choose the correct reference when creating other objects.

Note 2: all elements inside the Part are referenced to the Part's Origin which means that the Part can be moved and rotated in reference to the global coordinate system without affecting the placement of the elements inside.

Gestión de visibilidad

La visibilidad de la Part reemplaza la visibilidad de cualquier objeto que contenga. Si la Part está oculta, los objetos que contiene también estarán ocultos, incluso si su visibilidad está establecida en verdadero. Múltiples objetos dentro de una Part pueden ser visibles a la vez.

The Part's visibility supersedes the visibility of any object it contains. If the Part is hidden, the objects it contains will be hidden as well, even if their individual VistaVisibility property is set to true. If the Part is visible, then each object's VistaVisibility determines whether the object is shown or not.

The visibility of the Std Part determines whether the objects grouped under it are shown in the 3D view or not. Left: the Part is hidden, so none of the objects will be shown in the 3D view. Right: the Part is visible, so each object controls its own visibility.

Scripting

See also: FreeCAD Scripting Basics and scripted objects.

See Part Feature for the general information on adding objects to the document.

A Std Part (App Part) is created with the addObject() method of the document. Once a Part exists, other objects can be added to it with the addObject() or addObjects() methods.

import FreeCAD as App

doc = App.newDocument()
part = App.ActiveDocument.addObject("App::Part", "Part")

obj1 = App.ActiveDocument.addObject("PartDesign::Body", "Body")
obj2 = App.ActiveDocument.addObject("Part::Box", "Box")

part.addObjects([obj1, obj2])
App.ActiveDocument.recompute()

You cannot create a scripted App::Part. However, you can add App::Part behavior to a scripted Part::FeaturePython object by using the following code:

class MyGroup(object):
    def __init__(self, obj=None):
        self.Object = obj
        if obj:
            self.attach(obj)

    def dumps(self):
        return

    def loads(self, _state):
        return

    def attach(self, obj):
        obj.addExtension("App::OriginGroupExtensionPython")
        obj.Origin = FreeCAD.ActiveDocument.addObject("App::Origin", "Origin")

    def onDocumentRestored(self, obj):
        self.Object = obj

class ViewProviderMyGroup(object):
    def __init__(self, vobj=None):
        if vobj:
            vobj.Proxy = self
            self.attach(vobj)
        else:
            self.ViewObject = None

    def attach(self, vobj):
        vobj.addExtension("Gui::ViewProviderOriginGroupExtensionPython")
        self.ViewObject = vobj

    def dumps(self):
        return None

    def loads(self, _state):
        return None

App.ActiveDocument.addObject("Part::FeaturePython",
                             "Group",
                             group.MyGroup(),
                             group.ViewProviderMyGroup(),
                             True)